import { Component, createEffect, createResource, For } from 'solid-js';

import OlMap from 'ol/Map';

import dispatch from '../../workers/dispatcher-main';
import getUri from '../../lib/ids';

import Trkseg from '../trkseg';
import VectorSource from 'ol/source/Vector';

interface Props {
  trkId: string;
  vectorSource: VectorSource;
}
export const Trk: Component<Props> = ({ vectorSource, trkId }) => {
  const [trk] = createResource(
    trkId,
    async () =>
      await dispatch({
        action: 'getTrk',
        params: {
          id: trkId,
        },
      })
  );

  createEffect(() => {
    console.log({ caller: 'Trk', vectorSource, trkId, trk: trk() });
  });

  return (
    // @ts-ignore
    <For each={trk() ? trk().trkseg || [] : []}>
      {(trksegId: string) => {
        console.log({ caller: 'Trk / loop', trksegId });
        return <Trkseg vectorSource={vectorSource} trksegId={trksegId} />;
      }}
    </For>
  );
};

export default Trk;
